;*****************************************	*
;   Programm:   Charger for accumulator			*
;                                                                     		*
;*****************************************	*
;                                                                     		*
;    Filename:  charger.asm                                           	*
;    Date:      01.06.06                                              	*
;    File Version:  01                                               	*
;                                                                     		*
;    Author:          Kusnetsov Alexander                          	*
;                                                       				*
;*****************************************	*

	list      p=12f629           ; list directive to define processor
	#include <p12f629.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file



;***** VARIABLE DEFINITIONS
	cblock 0x20
	CNT_PUSK			;   PUSK
       DLLO				; /  0.5 
	DLMI				;-//-
	DLHI				; -//-
        endc	


;***** CONSTANTS DEFINITIONS
U_10.6		equ b'10001001'		; 10.6
U_13.8		equ b'10001110'		; 13.8
U_14.4		equ b'10001111'		; 14.4

;CLBR		equ b'01000000'		; 

;	 :
;	-GP0-  -  1  ""
;	-GP1-  "-"   -   .
;	-GP2-  - I- 
;	-GP3-  -  ""
;	-GP4-  - III- 
;	-GP5- - II- 

;**********************************************************************
		ORG     0x000             ; processor reset vector
		goto    Main              ; go to beginning of program

			
		

;*******
Main    	bsf     STATUS,RP0        ; set file register bank to 1 
		movlw	b'01000000'		;  
		movwf   OSCCAL            ; update register with factory cal value 
		bcf     STATUS,RP0        ; set file register bank to 0


		clrf		GPIO 	             	; 
	      	movlw	0x07              	; 
        	movwf	CMCON

        	banksel	TRISIO           	;  1.
        	movlw	b'00001010'       	; GPIO: GP0,GP2,GP4,GP5-, GP1,GP3 -.
        	movwf	TRISIO

		banksel	GPIO    	
        	bcf		GPIO, 0			; 
        	bcf		GPIO, 2			;I- 
        	bcf		GPIO, 4			;III- 
        	bcf		GPIO, 5			;II-                	
        	
        	banksel	CMCON
        	movlw	b'00000100'		; 
        	movwf	CMCON
        	
        	banksel	VRCON
        	movlw	U_10.6			;   2.66 
        	movwf	VRCON
        	
		;***************************************
		banksel	GPIO 
begin	call		sec_05			; 
Btn		btfsc	GPIO, 3          	; RUN ?
		goto 	$-1           		;,   
		incfsz 	CNT_PUSK, f  	;,   .
		goto 	Btn                	;  .
	                 				       ;,    
		;   3.
		movlw .90
		movwf DLLO
		movlw .138
		movwf DLMI
		movlw .10
		movwf DLHI

Btn1	btfsc	GPIO, 3          	; RUN ?		
		goto 	Run				;,    
		decfsz DLLO,f 
        	goto $-3 
        	decfsz DLMI,f 
        	goto $-5
        	decfsz DLHI,f 
        	goto $-7
        	goto 	Zar3				;  
		; 
Run		btfsc	CMCON, 6		; 
		goto	Zar		       	; . < 10 ,  
        	bsf		GPIO, 5			; . > 10,  
        	call		sec_45			; 
        	goto	Run
Zar
		banksel	VRCON
        	movlw	U_14.4			;   3.59 
        	movwf	VRCON
		banksel	GPIO
Zar2	call		ZAR_I   	
        	bsf		GPIO, 2			;  I-step
        	call		sec_45			; 45 
        			
        	btfss	CMCON, 6		; -  14.4
        	goto	M2				;  2 
        	call		RAZRYD		; 
        	bsf		GPIO, 4			;  III-step
        	call		sec_15			; 15   III-
        	goto	Zar2			;  


M2		bcf		GPIO, 2			; 1 
		call		sec_05			;
		bsf		GPIO, 5			;  II-step
M4		call		sec_45			; 45 		       	
        	btfss	CMCON, 6		; -  14.4
        	goto	M3				;,   3 
        	goto	M4				;,    

M3		bcf		GPIO, 5			; 2 
		call		sec_05
		banksel	VRCON
	       movlw	U_13.8			;   3.44 
        	movwf	VRCON
		banksel	GPIO
		goto	M7
M5		bsf		GPIO, 4			; III 
M7		call		sec_15			; 15 
		btfss	CMCON, 6		; -  13.8
        	goto	M6				;,   
        	goto	M5				;,    
M6		bcf		GPIO, 4			; III 
		goto	M7				; 

Zar3
		banksel	VRCON
        	movlw	U_14.4			;   3.59 
        	movwf	VRCON
		banksel	GPIO
		call		ZAR_I   	
        	bsf		GPIO, 2			;  I-step

Zar4       call		sec_45			; 45 
        	btfss	CMCON, 6		; -  14.4
        	goto	M2				;,  2 
        	goto	Zar4			;,    
		;******************************************
		;   0.5sec
		;******************************************
sec_05
		;
		movlw .90
		movwf DLLO
		movlw .138
		movwf DLMI
		movlw .3
		movwf DLHI
Del05	; 
		decfsz DLLO,f 
        	goto $-1 
        	decfsz DLMI,f 
        	goto $-3
        	decfsz DLHI,f 
        	goto $-5
		return
		;******************************************
		;   15sec
		;******************************************
sec_15
		;
		movlw .0
		movwf DLLO
		movlw .30
		movwf DLMI
		movlw .77
		movwf DLHI
Del15	; 
		decfsz DLLO,f 
        	goto $-1 
        	decfsz DLMI,f 
        	goto $-3
        	decfsz DLHI,f 
        	goto $-5
		return
		;******************************************
		;   45sec
		;******************************************
sec_45
		;
		movlw .0
		movwf DLLO
		movlw .100
		movwf DLMI
		movlw .229
		movwf DLHI
Del45	; 
		decfsz DLLO,f 
        	goto $-1 
        	decfsz DLMI,f 
        	goto $-3
        	decfsz DLHI,f 
        	goto $-5
		return
;****************************************************
;		   
;****************************************************
ZAR_I		
			bcf		GPIO, 2			; 
			bcf		GPIO, 4
			bcf		GPIO, 5
			call		sec_05			; 
			bsf		GPIO, 0			; 									
			call		sec_05			; 
			
			return
;****************************************************
;		   
;****************************************************			
RAZRYD			
			bcf		GPIO, 2			; 
			bcf		GPIO, 4
			bcf		GPIO, 5
			call		sec_05			; 
			bcf		GPIO, 0			; 									
			call		sec_05			; 
			
 			return       	


		END                       ; directive 'end of program'

